## TODO: remove paths to personal scratchs 
source("/esarchive/scratch/vagudets/repos/csoperational/R/get_regrid_params.R")
source("/esarchive/scratch/vagudets/repos/cstools/R/s2dv_cube.R")
# Load required libraries/funs
source("modules/data_load/dates2load.R")
source("tools/libs.R")

path <- "/esarchive/scratch/lpalma/git/startR-test-attrDims/R/"
ff <- lapply(list.files(path), function(x) paste0(path, x))
invisible(lapply(ff, source))

## TODO: Move to CSOperational
# Conversion from startR_array to s2dv_array
#-------------------------------------------------------------------
attr2array <- function(attr){
  return(array(as.vector(attr), dim(attr)))
}

startR_to_s2dv <- function(startR_array){

  dates_dims <- dim(Subset(startR_array, 
                           along=c('dat','var',
                           'latitude', 'longitude', 'ensemble'), 
                           list(1,1,1,1,1), drop="selected")) 

  #sdates_dims <- dim(Subset(startR_array, 
  #                         along=c('dat','var','time','sweek','sday',
  #                         'latitude', 'longitude', 'ensemble'), 
  #                         list(1,1,1,1,1,1,1,1), drop="selected")) 

  dates_start <- attr(startR_array, 'Variables')$common$time
  dates_end <- attr(startR_array, 'Variables')$common$time
  #sdates <-  unlist(attr(startR_array, 'FileSelectors')$dat1$file_date)

  dim(dates_start) <- dates_dims
  dim(dates_end) <- dates_dims
  #dim(sdates) <- sdates_dims

  ## TODO: change this line when time attributes work correctly?
  time_dims <- c("time", "sday", "sweek", "syear", "fcst_syear")

  s2dv_object <- s2dv_cube(data = attr2array(startR_array), 
                           lon = attr2array(attr(startR_array,
                                            'Variables')$dat1$longitude),
                           lat = attr2array(attr(startR_array,
                                            'Variables')$dat1$latitude),
                           Variable = list(varName=names(attr(startR_array,
							                            'Variables')$common)[2],
                                           level = NULL),
                           Dates = list(start = dates_start,
                                        end = dates_end),
                                        #sdate = sdates),
			               time_dims = time_dims,
                           when = Sys.time(),
                           source_files = attr2array(attr(startR_array, "Files"))
          #Datasets=list(exp1=list(InitializationsDates=list(Member_1="01011990", 
          #                                                  Members="Member_1")))
                          ) 
  return(s2dv_object)
}

# RECIPE FOR TESTING
# --------------------------------------------------------------------------------
# recipe_file <- "modules/data_load/testing_recipes/recipe_3.yml"
# recipe_file <- "modules/data_load/testing_recipes/recipe_2.yml"
# recipe_file <- "modules/data_load/testing_recipes/recipe_1.yml"

load_datasets <- function(recipe_file){

  ## TODO: Get only the last part of the path as the recipe$filename? 
  recipe <- read_yaml(recipe_file)
  recipe$filename <- recipe_file 

  ## TODO: this should come from the main script 
  # Create output folder and log:
  logger <- prepare_outputs(recipe = recipe) 
  folder <- logger$foldername
  log_file <- logger$logname
  logger <- logger$logger

  # -------------------------------------------
  # Set params -----------------------------------------

  hcst.inityear <- recipe$Analysis$Time$hcst_start
  hcst.endyear <- recipe$Analysis$Time$hcst_end
  lats.min <- recipe$Analysis$Region$latmin
  lats.max <- recipe$Analysis$Region$latmax
  lons.min <- recipe$Analysis$Region$lonmin
  lons.max <- recipe$Analysis$Region$lonmax
  ref.name <- recipe$Analysis$Datasets$Reference$name
  exp.name <- recipe$Analysis$Datasets$System$name
  
  variable <- recipe$Analysis$Variables$name
  store.freq <- recipe$Analysis$Variables$freq

  # get sdates array
  sdates <- dates2load(recipe, logger)

  idxs <- NULL
  idxs$hcst <- get_timeidx(sdates$hcst,
                           recipe$Analysis$Time$leadtimemin,
                           recipe$Analysis$Time$leadtimemax,
                           time_freq=store.freq)

  idxs$fcst <- get_timeidx(sdates$fcst,
                           recipe$Analysis$Time$leadtimemin,
                           recipe$Analysis$Time$leadtimemax,
                           time_freq=store.freq)

  ## TODO: Examine this verifications part, verify if it's necessary
  # stream <- verifications$stream
  # sdates <- verifications$fcst.sdate
  
  ## TODO: define fcst.name
  ##fcst.name <- recipe$Analysis$Datasets$System[[sys]]$name
  
  # get esarchive datasets dict:
  archive <- read_yaml(paste0(recipe$Run$code_dir, "conf/archive.yml"))$archive
  exp_descrip <- archive$System[[exp.name]]
  
  freq.hcst <- unlist(exp_descrip[[store.freq]][variable])
  reference_descrip <- archive$Reference[[ref.name]]
  freq.obs <- unlist(reference_descrip[[store.freq]][variable])
  obs.dir <- reference_descrip$src
  fcst.dir <- exp_descrip$src 
  hcst.dir <- exp_descrip$src
  fcst.nmember <- exp_descrip$nmember$fcst
  hcst.nmember <- exp_descrip$nmember$hcst
  
  ## TODO: it is necessary?
  ##if ("accum" %in% names(reference_descrip)) {
  ##  accum <- unlist(reference_descrip$accum[store.freq][[1]])
  ##} else {
  ##  accum <- FALSE
  ##}
  
  # -----------
  obs.path <- paste0(archive$src,
              obs.dir, store.freq, "/$var$",
              reference_descrip[[store.freq]][[variable]],"$var$_$file_date$.nc")
  
  hcst.path <- paste0(archive$src,
               hcst.dir, store.freq, "/$var$",
               exp_descrip[[store.freq]][[variable]],"$var$_$file_date$.nc")
  
  fcst.path <- paste0(archive$src,
               hcst.dir, store.freq, "/$var$",
  	           exp_descrip[[store.freq]][[variable]],"$var$_$file_date$.nc")
  
  # Define regrid parameters:
  #-------------------------------------------------------------------
  regrid_params <- get_regrid_params(recipe, archive)
  
  # Longitude sort
  #-------------------------------------------------------------------
  if (lons.min >= 0) {
    circularsort <- CircularSort(0, 360)
  } else {
    circularsort <- CircularSort(-180, 180)
  }

  if (recipe$Analysis$Variables$freq == "monthly_mean"){
    split_multiselected_dims = TRUE
  } else {
    split_multiselected_dims = FALSE
  }
  
  # Load hindcast 
  #-------------------------------------------------------------------
  hcst <- Start(dat = hcst.path,
                var = variable,
                file_date = sdates$hcst,
                time = idxs$hcst,
                latitude = values(list(lats.min, lats.max)),
                latitude_reorder = Sort(),
                longitude = values(list(lons.min, lons.max)),
                longitude_reorder = circularsort,
                transform = regrid_params$fcst.transform,
                transform_params = list(grid = regrid_params$fcst.gridtype,
                                        method = regrid_params$fcst.gridmethod),
                transform_vars = c('latitude', 'longitude'),
                synonims = list(latitude = c('lat', 'latitude'),
                                longitude = c('lon', 'longitude'),
  			                    ensemble = c('member', 'ensemble')),
                ensemble = indices(1:hcst.nmember),
                return_vars = list(latitude = 'dat',
                                   longitude = 'dat',
                                   time = 'file_date'),
                split_multiselected_dims = split_multiselected_dims,
                retrieve = TRUE)

  if (recipe$Analysis$Variables$freq == "daily_mean"){
    # Adjusts dims for daily case, could be removed if startR allows
    # multidim split
    names(dim(hcst))[which(names(dim(hcst)) == 'file_date')] <- "syear"
    default_dims <- c(dat = 1, var = 1, sweek = 1, 
                      sday = 1, syear = 1, time = 1, 
                      latitude = 1, longitude = 1, ensemble = 1)
    default_dims[names(dim(hcst))] <- dim(hcst)
    dim(hcst) <- default_dims
  }
  hcst <- startR_to_s2dv(hcst)
  
  # Load forecast
  #-------------------------------------------------------------------
  if (!is.null(recipe$Analysis$Time$sdate$fcst_syear)){
    
    fcst <- Start(dat = fcst.path,
    	          var = variable,
    	          file_date = sdates$fcst,
                  time = idxs$fcst,
    	          latitude = values(list(lats.min, lats.max)),
    	          latitude_reorder = Sort(),
    	          longitude = values(list(lons.min, lons.max)),
    	          longitude_reorder = circularsort,
    	          transform = regrid_params$fcst.transform,
    	          transform_params = list(grid = regrid_params$fcst.gridtype,
    		        	                  method = regrid_params$fcst.gridmethod),
    	          transform_vars = c('latitude', 'longitude'),
    	          synonims = list(latitude = c('lat', 'latitude'),
    		                      longitude = c('lon', 'longitude'),
    		                      ensemble = c('member', 'ensemble')),
    	          ensemble = indices(1:fcst.nmember),
    	          return_vars = list(latitude = 'dat',
    		        	             longitude = 'dat',
    		        	             time = 'file_date'),
                  split_multiselected_dims = split_multiselected_dims,
    	          retrieve = TRUE)
  
    names(dim(fcst))[which(names(dim(fcst)) == 'file_date')] <- "fcst_year"
    fcst <- startR_to_s2dv(fcst)

  } else {
    fcst <- NULL 
  }
  
  # Load reference
  #-------------------------------------------------------------------
  ## TODO: Replace with new code once An-Chi's fix is released in StartR
  dates <- hcst$Dates$start 
 
  # Separate Start() call for monthly vs daily data
  if (store.freq == "monthly_mean") {
  
    dates_file <- sapply(dates, format, '%Y%m%d')
    dates_file <- format(as.Date(dates_file, '%Y%m%d'), "%Y%m")
    dim(dates_file) <- dim(Subset(hcst$data, 
                                  along=c('dat','var',
                                  'latitude', 'longitude', 'ensemble'), 
                                  list(1,1,1,1,1), drop="selected"))

    obs <- Start(dat = obs.path,
  	             var = variable,
  	             file_date = dates_file,
  	             merge_across_dims = TRUE,
  	             merge_across_dims_narm = TRUE,
  	             latitude = values(list(lats.min, lats.max)),
  	             latitude_reorder = Sort(),
  	             longitude = values(list(lons.min, lons.max)),
  	             longitude_reorder = circularsort,
  	             transform = regrid_params$obs.transform,
  	             transform_params = list(grid = regrid_params$obs.gridtype,
  		          	                   method = regrid_params$obs.gridmethod),
  	             transform_vars = c('latitude', 'longitude'),
  	             synonims = list(latitude = c('lat','latitude'),
  		                         longitude = c('lon','longitude')),
  	             return_vars = list(latitude = 'dat',
  		          	              longitude = 'dat',
  		          	              time = 'file_date'),
  	             split_multiselected_dims = TRUE,
  	             retrieve = TRUE)
  
  } else if (store.freq == "daily_mean") {

    # Get year and month for file_date
    dates_file <- sapply(dates, format, '%Y%m')
    dim(dates_file) <- dim(dates)
    # Set hour to 12:00 to ensure correct date retrieval for daily data
    lubridate::hour(dates) <- 12 
    lubridate::minute(dates) <- 00
    # Restore correct dimensions
    dim(dates) <- dim(dates_file)
   
    obs <- Start(dat = obs.path,
  	             var = variable,
  	             file_date = sort(unique(dates_file)),
  	             time = dates,
  	             time_var = 'time',
  	             time_across = 'file_date',
  	             merge_across_dims = TRUE,
  	             merge_across_dims_narm = TRUE,
  	             latitude = values(list(lats.min, lats.max)),
  	             latitude_reorder = Sort(),
  	             longitude = values(list(lons.min, lons.max)),
  	             longitude_reorder = circularsort,
  	             transform = regrid_params$obs.transform,
  	             transform_params = list(grid = regrid_params$obs.gridtype,
  	              		               method = regrid_params$obs.gridmethod),
  	             transform_vars = c('latitude', 'longitude'),
  	             synonims = list(latitude = c('lat','latitude'),
  	  	                         longitude = c('lon','longitude')),
  	             return_vars = list(latitude = 'dat',
  		          	              longitude = 'dat',
  		          	              time = 'file_date'),
  	             split_multiselected_dims = TRUE,
  	             retrieve = TRUE)
  }
  
  # TODO: Reorder obs dims to match hcst dims?
  # Adds ensemble dim to obs (for consistency with hcst/fcst)
  default_dims <- c(dat = 1, var = 1, sweek = 1, 
                    sday = 1, syear = 1, time = 1, 
                    latitude = 1, longitude = 1, ensemble = 1)
  default_dims[names(dim(obs))] <- dim(obs)
  dim(obs) <- default_dims
  
  obs <- startR_to_s2dv(obs)
  
  ############################################################################
  #
  #     CHECKS ON MISSING FILES
  #
  ############################################################################
  
  #obs.NA_dates.ind <- Apply(obs, 
  #                          fun=(function(x){ all(is.na(x))}), 
  #                          target_dims=c('time', 'latitude', 'longitude'))[[1]]
  #obs.NA_dates <- dates_file[obs.NA_dates.ind]
  #obs.NA_dates <- obs.NA_dates[order(obs.NA_dates)]
  #obs.NA_files <- paste0(obs.dir, store.freq,"/",variable,"_",
  #                       freq.obs,"obs.grid","/",variable,"_",obs.NA_dates,".nc")
  #
  #if (any(is.na(hcst))){
  #  fatal(logger,
  #    paste(" ERROR: MISSING HCST VALUES FOUND DURING LOADING # ",
  #          " ################################################# ",
  #          " ######           MISSING FILES               #### ",
  #          " ################################################# ",
  #          "hcst files:",
  #          hcst.NA_files,
  #          " ################################################# ",
  #          " ################################################# ",
  #          sep="\n"))
  #  quit(status = 1)
  #}
  #
  #if (any(is.na(obs)) && !identical(obs.NA_dates,character(0))){
  #  fatal(logger,
  #    paste(" ERROR: MISSING OBS VALUES FOUND DURING  LOADING # ",
  #          " ################################################# ",
  #          " ######           MISSING FILES               #### ",
  #          " ################################################# ",
  #          "obs files:",
  #          obs.NA_files,
  #          " ################################################# ",
  #          " ################################################# ",
  #          sep="\n"))
  #  quit(status=1)
  #}
  #
  #info(logger,
  #     "######### DATA LOADING COMPLETED SUCCESFULLY ##############")
  
  ############################################################################
  ############################################################################
 
  ## TODO: we need to define accumulated vars
  #filters negative values in accum vars
  #if (accum){
  #   obs$data[obs$data < 0 ] <- 0
  #   hcst$data[hcst$data < 0 ] <- 0
  #   if (!is.null(fcst)){
  #     fcst$data[fcst$data < 0 ] <- 0
  #   }
  #}
  
  return(list(hcst = hcst, fcst = fcst, obs = obs))

}
